void dcf_counter_reset(void) 
{
    dcf_struct.counter_low=0;
    dcf_struct.bit_number=0;
}

void dcf_date_reset(void) 
{
    dcf_struct.week_day=0;
    dcf_struct.day=0;
    dcf_struct.month=0;
    dcf_struct.year=0;
    dcf_struct.date_parity=0;
    dcf_struct.day_check=0;
    dcf_struct.month_check=0;
    dcf_struct.year_check=0;
}

void dcf_time_reset(void) 
{
    dcf_struct.minute=0;
    dcf_struct.minute_parity=0;
    dcf_struct.hour=0;
    dcf_struct.hour_parity=0;
    dcf_struct.timezone=0;
    dcf_struct.minute_check=0;
    dcf_struct.hour_check=0;
}

// Stores value of current DFC cycle and resets some value to start a new cycle for comparisation

void dcf_store_check(void) 
{
    //save actual dcf values
    dcf_struct.day_check=dcf_struct.day;
    dcf_struct.month_check=dcf_struct.month;
    dcf_struct.year_check=dcf_struct.year;
    dcf_struct.minute_check=dcf_struct.minute;
    dcf_struct.hour_check=dcf_struct.hour;
    //and reset dcf values to start a new dcf reading for comparisation
    dcf_struct.week_day=0;    
    dcf_struct.day=0;
    dcf_struct.month=0;
    dcf_struct.year=0;
    dcf_struct.date_parity=0;
    dcf_struct.minute=0;
    dcf_struct.minute_parity=0;
    dcf_struct.hour=0;
    dcf_struct.hour_parity=0;
    dcf_struct.timezone=0;
}
        
//DCF-Evaluation

void dcf_0(void) 
{
    switch(dcf_struct.bit_number)
        {
	case 0: ;break;	//new minute, always 0
	case 1: ;break;	//weather data
	case 2: ;break;	//weather data
	case 3: ;break;	//weather data
	case 4: ;break;	//weather data
	case 5: ;break;	//weather data
	case 6: ;break;	//weather data
	case 7: ;break;	//weather data
	case 8: ;break;	//weather data
	case 9: ;break;	//weather data
	case 10: ;break;	//weather data
	case 11: ;break;	//weather data
	case 12: ;break;	//weather data
	case 13: ;break;	//weather data
	case 14: ;break;	//weather data
	case 15: ;break;	//callbit for PTB
	case 16: ;break; //no timezone change
	case 17: ;break;	//time zone
	case 18: dcf_struct.timezone+=1;break;	//time zone
	case 19: ;break;	//no switch second
	case 20: ;break;	//time info 
	case 21: ;break;
	case 22: ;break;
	case 23: ;break;
	case 24: ;break;
	case 25: ;break;
	case 26: ;break;
	case 27: ;break;
	case 28: ;break;	//parity minute
	case 29: ;break;
	case 30: ;break;
	case 31: ;break;
	case 32: ;break;
	case 33: ;break;
	case 34: ;break;
	case 35: ;break;	//parity hour
	case 36: ;break;
	case 37: ;break;
	case 38: ;break;
	case 39: ;break;
	case 40: ;break;
	case 41: ;break;
	case 42: ;break;
	case 43: ;break;
	case 44: ;break;
	case 45: ;break;
	case 46: ;break;
	case 47: ;break;
	case 48: ;break;
	case 49: ;break;
	case 50: ;break;
	case 51: ;break;
	case 52: ;break;
	case 53: ;break;
	case 54: ;break;
	case 55: ;break;
	case 56: ;break;
	case 57: ;break;
	case 58: ;break;	//parity date
	case 59: ;break;	//sync - new minute
        default: dcf_counter_reset();break;
        }
}

void dcf_1(void) 
{
    switch(dcf_struct.bit_number)
        {
	case 0: ;break;	//new minute, always 0
	case 1: ;break;	//weather data
	case 2: ;break;	//weather data
	case 3: ;break;	//weather data
	case 4: ;break;	//weather data
	case 5: ;break;	//weather data
	case 6: ;break;	//weather data
	case 7: ;break;	//weather data
	case 8: ;break;	//weather data
	case 9: ;break;	//weather data
	case 10: ;break;	//weather data
	case 11: ;break;	//weather data
	case 12: ;break;	//weather data
	case 13: ;break;	//weather data
	case 14: ;break;	//weather data
	case 15: ;break;	//callbit for PTB
	case 16: ;break; //switch hour at the end of this hour
	case 17: dcf_struct.timezone+=1;break;	//time zone
	case 18: ;break;	//time zone
	case 19: ;break;	//switch second at the end of this hour
	case 20: ;break;	//time info 
	case 21: dcf_struct.minute+=1;dcf_struct.minute_parity+=1;break;
	case 22: dcf_struct.minute+=2;dcf_struct.minute_parity+=1;break;
	case 23: dcf_struct.minute+=4;dcf_struct.minute_parity+=1;break;
	case 24: dcf_struct.minute+=8;dcf_struct.minute_parity+=1;break;
	case 25: dcf_struct.minute+=10;dcf_struct.minute_parity+=1;break;
	case 26: dcf_struct.minute+=20;dcf_struct.minute_parity+=1;break;
	case 27: dcf_struct.minute+=40;dcf_struct.minute_parity+=1;break;
	case 28: dcf_struct.minute_parity+=1;break;	//parity minute
	case 29: dcf_struct.hour+=1;dcf_struct.hour_parity+=1;break;
	case 30: dcf_struct.hour+=2;dcf_struct.hour_parity+=1;break;
	case 31: dcf_struct.hour+=4;dcf_struct.hour_parity+=1;break;
	case 32: dcf_struct.hour+=8;dcf_struct.hour_parity+=1;break;
	case 33: dcf_struct.hour+=10;dcf_struct.hour_parity+=1;break;
	case 34: dcf_struct.hour+=20;dcf_struct.hour_parity+=1;break;
	case 35: dcf_struct.hour_parity+=1;break;	//parity hour
	case 36: dcf_struct.day+=1;dcf_struct.date_parity+=1;break;
	case 37: dcf_struct.day+=2;dcf_struct.date_parity+=1;break;
	case 38: dcf_struct.day+=4;dcf_struct.date_parity+=1;break;
	case 39: dcf_struct.day+=8;dcf_struct.date_parity+=1;break;
	case 40: dcf_struct.day+=10;dcf_struct.date_parity+=1;break;
	case 41: dcf_struct.day+=20;dcf_struct.date_parity+=1;break;
	case 42: dcf_struct.week_day+=1;dcf_struct.date_parity+=1;break;
	case 43: dcf_struct.week_day+=2;dcf_struct.date_parity+=1;break;
	case 44: dcf_struct.week_day+=4;dcf_struct.date_parity+=1;break;
	case 45: dcf_struct.month+=1;dcf_struct.date_parity+=1;break;
	case 46: dcf_struct.month+=2;dcf_struct.date_parity+=1;break;
	case 47: dcf_struct.month+=4;dcf_struct.date_parity+=1;break;
	case 48: dcf_struct.month+=8;dcf_struct.date_parity+=1;break;
	case 49: dcf_struct.month+=10;dcf_struct.date_parity+=1;break;
	case 50: dcf_struct.year+=1;dcf_struct.date_parity+=1;break;
	case 51: dcf_struct.year+=2;dcf_struct.date_parity+=1;break;
	case 52: dcf_struct.year+=4;dcf_struct.date_parity+=1;break;
	case 53: dcf_struct.year+=8;dcf_struct.date_parity+=1;break;
	case 54: dcf_struct.year+=10;dcf_struct.date_parity+=1;break;
	case 55: dcf_struct.year+=20;dcf_struct.date_parity+=1;break;
	case 56: dcf_struct.year+=40;dcf_struct.date_parity+=1;break;
	case 57: dcf_struct.year+=80;dcf_struct.date_parity+=1;break;
	case 58: dcf_struct.date_parity+=1;break;	//parity date
	case 59: ;break;	//sync - new minute
        default: dcf_counter_reset();break;
        }
}

//write DCF data to internal time structure variables

void dcf_match_date(void)
{
    time.d=dcf_struct.day;
    time.mo=dcf_struct.month;
    time.y=dcf_struct.year;
    dcf_struct.day_check=0;
    dcf_struct.month_check=0;
    dcf_struct.year_check=0;
}

void dcf_match_time(void)
{
    ctrl_struct.dcf_sync=TRUE;
    ctrl_struct.timeunknown = FALSE;
    time.s=0;
    time.m=dcf_struct.minute;
    time.h=dcf_struct.hour;
    dcf_struct.minute_check=0;
    dcf_struct.hour_check=0;
    //time.z=dcf_timezone; //not neccessary since we calculate it on our own
}

 
